"use strict";
this.name           = "SC worldscript events";
this.author         = "Lone_Wolf";
this.copyright      = "(C) 2011,2012 , 2014 Lone_Wolf.";
this.licence        = "CC-by-SA 4.0";
this.description    = "SC worldscript event handler";
this.version        = "1.10.2";

this.startUp = function()
  {
    if ( worldScripts["Shield Cycler"].startUp ) { worldScripts["Shield Cycler"].startUp(); };
  };

// worldscript events
this.guiScreenWillChange = function(to, from)
  {
    if ( to !== "GUI_SCREEN_MANIFEST" ) { return; };
    if ( worldScripts["Shield Cycler"]._sc_settings.sc.version == worldScripts["Shield Cycler"]._sc_const.none ) { return; };
    var _sc_display_strings = ["none","basic","standard","advanced"];
    var sc_display_cycler = _sc_display_strings[worldScripts["Shield Cycler"]._sc_settings.sc.version];
    var sc_display_manual = "";
    var sc_display_functional = worldScripts["Shield Cycler"]._sc_settings.sc.functional ;
    if ( worldScripts["Shield Cycler"]._sc_settings.sc.manual_version != worldScripts["Shield Cycler"]._sc_const.none )
      { var sc_display_manual = _sc_display_strings[worldScripts["Shield Cycler"]._sc_settings.sc.manual_version]; };
    mission.setInstructions("Shield Cycler: " + sc_display_cycler +" ,Manual Configurator: " + sc_display_manual + " , " + sc_display_functional + " %% functional");
  };

this.playerWillSaveGame = function()
  {
    missionVariables.sc_settings = JSON.stringify(worldScripts["Shield Cycler"]._sc_settings);
  };

this.playerBoughtNewShip = function(ship)
  {
    // sell shieldcycler equipment if still present and reset missionvars
    if ( worldScripts["Shield Cycler"]._sc_settings.sc.version == worldScripts["Shield Cycler"]._sc_const.none ) { return; };
    var refund = 0;
    if ( worldScripts["Shield Cycler"]._sc_settings.sc.manual_version != worldScripts["Shield Cycler"]._sc_const.none ) 
      { 
	var refund = this._sc_sell_manual();
      };
    refund = refund + this._sc_sell_shield_cycler();
    player.credits = player.credits + refund;
  };

this.playerBoughtEquipment = function(equipmentKey)
  {
    // This function supplements the code in equipment.plist & SC_Equipment_Condtion.js
    switch ( equipmentKey )
        {
          case "EQ_SC_SHIELD_CYCLER_BASIC":
            player.ship.removeEquipment(equipmentKey);
	    player.ship.awardEquipment("EQ_SC_SHIELD_CYCLER_INTERNAL");
            worldScripts["Shield Cycler"]._sc_settings.sc.start_configuration = worldScripts["Shield Cycler"]._sc_const.cycle.both;
            worldScripts["Shield Cycler"]._sc_settings.sc.threshold = 100;
	    worldScripts["Shield Cycler"]._sc_update_oxpconfig_vars();
            worldScripts["Shield Cycler"]._sc_settings.sc.functional = 100;
	    worldScripts["Shield Cycler"]._sc_settings.sc.version  = worldScripts["Shield Cycler"]._sc_const.basic;
            break;
          case "EQ_SC_SHIELD_CYCLER_STANDARD":
            player.ship.removeEquipment(equipmentKey);
            worldScripts["Shield Cycler"]._sc_change_configuration(1, false);
	    worldScripts["Shield Cycler"]._sc_settings.sc.version  = worldScripts["Shield Cycler"]._sc_const.standard;
            break;
          case "EQ_SC_SHIELD_CYCLER_ADVANCED":
            player.ship.removeEquipment(equipmentKey);
            worldScripts["Shield Cycler"]._sc_change_configuration(2, false);
	    worldScripts["Shield Cycler"]._sc_settings.sc.version  = worldScripts["Shield Cycler"]._sc_const.advanced;
            break;
          case "EQ_SC_MANUAL_CONFIGURATOR_BASIC":
	    player.ship.removeEquipment(equipmentKey);
            player.ship.awardEquipment("EQ_SC_MANUAL_CONFIGURATOR_INTERNAL");
            worldScripts["Shield Cycler"]._sc_settings.sc.cycler_mask  = 0x00f;
	    worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  = worldScripts["Shield Cycler"]._sc_const.basic;
            break;
          case "EQ_SC_MANUAL_CONFIGURATOR_STANDARD":
	    player.ship.removeEquipment(equipmentKey);
	    worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  = worldScripts["Shield Cycler"]._sc_const.standard;
            break;
          case "EQ_SC_MANUAL_CONFIGURATOR_ADVANCED":
	    player.ship.removeEquipment(equipmentKey);
            worldScripts["Shield Cycler"]._sc_change_configuration(3, false);
	    worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  = worldScripts["Shield Cycler"]._sc_const.advanced;
            break;
          case "EQ_SC_SELL_MANUAL_CONFIGURATOR":
	    player.credits = player.credits + this._sc_sell_manual();
            break;
	  case "EQ_SC_SELL_SHIELD_CYCLER":
            player.credits = player.credits + this._sc_sell_shield_cycler();
            break;
          default:
            break;
        };
  };

  this._sc_sell_manual = function()
    {
      var refund1 = 0;
      // log(this.name,worldScripts["Shield Cycler"]._sc_settings.sc.manual_version);
      if ( worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  == worldScripts["Shield Cycler"]._sc_const.advanced )
	{
	  refund1 = EquipmentInfo.infoForKey("EQ_SC_MANUAL_CONFIGURATOR_ADVANCED").price;
	  worldScripts["Shield Cycler"]._sc_change_configuration(3, true);
	};
      if ( worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  == worldScripts["Shield Cycler"]._sc_const.standard )
	{
	  refund1 = refund1 + EquipmentInfo.infoForKey("EQ_SC_MANUAL_CONFIGURATOR_STANDARD").price;
	};
      if ( worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  == worldScripts["Shield Cycler"]._sc_const.basic )
	{
	  refund1 = refund1 + EquipmentInfo.infoForKey("EQ_SC_MANUAL_CONFIGURATOR_BASIC").price;
	};
      refund1 = refund1 * worldScripts["Shield Cycler"]._sc_settings.sc.functional * 0.01;
      player.ship.removeEquipment("EQ_SC_MANUAL_CONFIGURATOR_INTERNAL");
      worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  = worldScripts["Shield Cycler"]._sc_const.none;
      worldScripts["Shield Cycler"]._sc_settings.sc.cycler_mask  = 0x00f;
      worldScripts["Shield Cycler"]._sc_update_oxpconfig_vars();
      return parseInt(refund1 * 0.1 * 0.6) ;
    };

this._sc_sell_shield_cycler = function()
    {
      var refund1 = 0;
      if ( worldScripts["Shield Cycler"]._sc_settings.sc.version  == worldScripts["Shield Cycler"]._sc_const.advanced )
	{
	  refund1 = EquipmentInfo.infoForKey("EQ_SC_SHIELD_CYCLER_ADVANCED").price;
	  worldScripts["Shield Cycler"]._sc_change_configuration(2, true);
	  worldScripts["Shield Cycler"]._sc_change_configuration(1, true);
	};
      if ( worldScripts["Shield Cycler"]._sc_settings.sc.version  == worldScripts["Shield Cycler"]._sc_const.standard )
	{
	  refund1 = refund1 + EquipmentInfo.infoForKey("EQ_SC_SHIELD_CYCLER_STANDARD").price;
	  worldScripts["Shield Cycler"]._sc_change_configuration(1, true);
	};
      if ( worldScripts["Shield Cycler"]._sc_settings.sc.version  == worldScripts["Shield Cycler"]._sc_const.basic )
	{
	  refund1 = refund1 + EquipmentInfo.infoForKey("EQ_SC_SHIELD_CYCLER_BASIC").price;
	};
      refund1 = refund1 * worldScripts["Shield Cycler"]._sc_settings.sc.functional * 0.01;
      player.ship.removeEquipment("EQ_SC_SHIELD_CYCLER_INTERNAL");
      worldScripts["Shield Cycler"]._sc_settings.sc.version  = worldScripts["Shield Cycler"]._sc_const.none;
      worldScripts["Shield Cycler"]._sc_settings.sc.start_configuration = worldScripts["Shield Cycler"]._sc_const.both;
      worldScripts["Shield Cycler"]._sc_settings.sc.threshold = 100;
      worldScripts["Shield Cycler"]._sc_update_oxpconfig_vars();
      worldScripts["Shield Cycler"]._sc_settings.sc.functional = 100;
      return parseInt(refund1 * 0.1 * 0.6) ;
    };
